<?php

class EveryLoader extends Twig_Loader_Filesystem {

    function __construct($paths = array()) {
        parent::__construct($paths);
    }

    public function addPathAndSubfolders($folder_path, $namespace = Twig_Loader_Filesystem::MAIN_NAMESPACE, $exclude = array() ) {
        if(!file_exists($folder_path)) {
            throw new Twig_Error($folder_path . " does not exist");
        }

        $dir = new RecursiveDirectoryIterator($folder_path);
        $filtered = new DirFilter($dir, $exclude);

        foreach(new RecursiveIteratorIterator($filtered) as $d) {
            $this->addPath($d, $namespace);
        }
    }

    public function getChain(array $array) {
        return new Twig_Loader_Chain($array);
    }
}

class DirFilter extends RecursiveFilterIterator {
    protected $exclude;

    public function __construct($iterator, array $exclude) {
        parent::__construct($iterator);
        $this->exclude = $exclude;
    }

    public function accept() {
        return ($this->isDir() && !in_array($this->getFilename(), $this->exclude));
    }

    public function getChildren() {
        return new DirFilter($this->getInnerIterator()->getChildren(), $this->exclude);
    }
}